pro init_specred,targetid,targetsubid,ext_source_table,refimage_list,specimage_list,filter_spec, $
                 Root_dir=root_dir, $
                 Ns_spec=Ns_spec,Nh_spec=Nh_spec,Np_spec=Np_spec,Ls_spec=Ls_spec, $
                 brightest_10_source=brightest_10_source, $
                 no_tune_sourcepos=no_tune_sourcepos, $
                 use_short_refimage=use_short_refimage, $
                 interactive_skyset=interactive_skyseat, $
                 ds9_edit=ds9_edit, $
                 no_short=no_short, $
                 rotated_NIR_source_table=rotated_NIR_source_table, $
                 preflight_data=preflight_data,NP_linear=NP_linear,no_NP_distortion=no_NP_distortion,debug=debug, $
                 auto_image_stack=auto_image_stack, $
                 no_database_check=no_database_check,no_slit_flat=no_slit_flat, $
                 no_fov_mask=no_fov_mask,non_interactive=non_interactive,simple_skysub=simple_skysub, $
                 use_all_images=use_all_images

  common dir_structure,datadir,calibdir,datadir2,tmpdir,workdir
  common frame_type,chip,filter,grism
  common colors,black,magenta,cyan,yellow,green,red,blue,navy,aqua,orchid,sky,beige,charcoal,grey,white
  common measured_offsets,space_shift,nsum
  common gui,logger

  make_env_var                  ; make environment variables

; Interprete command line options and set variables accordingly.
  if keyword_set(no_short) then $
     !IRC_SPECRED_PROCESSOPTION.no_short_MODE=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.no_short_MODE=0B
  
  if keyword_set(brightest_10_source) then $
     !IRC_SPECRED_PROCESSOPTION.brightest_10_source_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.brightest_10_source_mode=0B
  
  if keyword_set(use_short_refimage) then $
     !IRC_SPECRED_PROCESSOPTION.use_short_refimage_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.use_short_refimage_mode=0B
  
  if keyword_set(interactive_skyset) then $
     !IRC_SPECRED_PROCESSOPTION.interactive_skyset_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.interactive_skyset_mode=0B

  if keyword_set(non_interactive) then $
     !IRC_SPECRED_PROCESSOPTION.non_interactive_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.non_interactive_mode=0B
  
  if keyword_set(ds9_edit) then $
     !IRC_SPECRED_PROCESSOPTION.ds9_edit_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.ds9_edit_mode=0B
  
  if keyword_set(rotated_NIR_source_table) then $
     !IRC_SPECRED_PROCESSOPTION.rotated_NIR_source_table_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.rotated_NIR_source_table_mode=0B
  
  if keyword_set(no_tune_sourcepos) then $
     !IRC_SPECRED_PROCESSOPTION.no_tune_sourcepos_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.no_tune_sourcepos_mode=0B
  
  if keyword_set(auto_image_stack) then $
     !IRC_SPECRED_PROCESSOPTION.auto_image_stack=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.auto_image_stack=0B
  
;
; Slit options
;
  
  if keyword_set(Ns_spec) || keyword_set(Nh_spec) || keyword_set(Ls_spec) then $
     !IRC_SPECRED_OBSPARAM.slit_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.slit_mode=0B
  
  if keyword_set(Np_spec) then $
     !IRC_SPECRED_OBSPARAM.Np_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.Np_mode=0B
  
  if keyword_set(Nh_spec) then $
     !IRC_SPECRED_OBSPARAM.Nh_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.Nh_mode=0B
  
  if keyword_set(Ns_spec) then $
     !IRC_SPECRED_OBSPARAM.Ns_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.Ns_mode=0B
  
  if keyword_set(Ls_spec) then $
     !IRC_SPECRED_OBSPARAM.Ls_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.Ls_mode=0B
  
;
; Maintenance mode options
;
  
  if keyword_set(NP_linear) then $
     !IRC_SPECRED_PROCESSOPTION.NP_linear_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.NP_linear_mode=0B
  
  if keyword_set(no_NP_distortion) then $
     !IRC_SPECRED_PROCESSOPTION.no_NP_distortion_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.no_NP_distortion_mode=0B
  
  if keyword_set(preflight_data) then $
     !IRC_SPECRED_OBSPARAM.preflight_mode=1B $
  else $
     !IRC_SPECRED_OBSPARAM.preflight_mode=0B
  
  if keyword_set(no_slit_flat) then $
     !IRC_SPECRED_PROCESSOPTION.no_slit_flat=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.no_slit_flat=0B
  
  if keyword_set(debug) then $
     !IRC_SPECRED_MISC.debug=1B $
  else $
     !IRC_SPECRED_MISC.debug=0B

  if keyword_set(no_fov_mask) then $
     !IRC_SPECRED_PROCESSOPTION.no_fov_mask=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.no_fov_mask=0B

  if keyword_set(simple_skysub) then $
     !IRC_SPECRED_PROCESSOPTION.simple_skysub_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.simple_skysub_mode=0B

  if keyword_set(use_all_images) then $
     !IRC_SPECRED_PROCESSOPTION.use_all_images_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.use_all_images_mode=0B

  if defined(ext_source_table) then $
     !IRC_SPECRED_PROCESSOPTION.ext_source_table_mode=1B $
  else $
     !IRC_SPECRED_PROCESSOPTION.ext_source_table_mode=0B
  
  do_param_initialize,filter_spec,targetid,targetsubid, $
                      root_dir=root_dir,refimage_list=refimage_list,no_database_check=no_database_check

; shift from file: use previously measured shift & add values amoung
; sub-frames for stacking
  
  if defined(ext_source_table) then begin
     if NIR() && ext_source_table NE '' then $
        !IRC_SPECRED_PROCESSOPTION.shift_from_file=1B $
     else $
        !IRC_SPECRED_PROCESSOPTION.shift_from_file=0B
  endif else $
     !IRC_SPECRED_PROCESSOPTION.shift_from_file=0B

  if keyword_set(Np_spec) then !IRC_SPECRED_PROCESSOPTION.shift_from_file=1B
  
end
