pro set_process_params,chip,grism

; sub-frame combine parameters

  !IRC_SPECRED_COMBINEPARAM.IMAG_COMBINE_MODE='median'
  !IRC_SPECRED_COMBINEPARAM.SPEC_COMBINE_MODE='average'

  case chip of
     0: !IRC_SPECRED_COMBINEPARAM.SPEC_COMBINE_SIGMA=3.
     1: !IRC_SPECRED_COMBINEPARAM.SPEC_COMBINE_SIGMA=3.
     2: !IRC_SPECRED_COMBINEPARAM.SPEC_COMBINE_SIGMA=3.
  endcase
  

 ; sky fitting parameters
  case chip of
     0: begin
        !IRC_SPECRED_SKYFITORDER.sky_fit_order=1
        !IRC_SPECRED_SKYFITORDER.sky_fit_indiv_order=1
        !IRC_SPECRED_SKYFITORDER.sky_fit_order_n=0
     end
     1: begin
        case grism of
           0: begin
              !IRC_SPECRED_SKYFITORDER.sky_fit_order=2
              !IRC_SPECRED_SKYFITORDER.sky_fit_indiv_order=1
              !IRC_SPECRED_SKYFITORDER.sky_fit_order_n=1
           end
           1: begin
              !IRC_SPECRED_SKYFITORDER.sky_fit_order=4
              !IRC_SPECRED_SKYFITORDER.sky_fit_indiv_order=6
              !IRC_SPECRED_SKYFITORDER.sky_fit_order_n=1
           end
        endcase
     end
     2: begin
        !IRC_SPECRED_SKYFITORDER.sky_fit_order=6
        !IRC_SPECRED_SKYFITORDER.sky_fit_indiv_order=6
        !IRC_SPECRED_SKYFITORDER.sky_fit_order_n=2
     end
  endcase

; source detection parameters
  if !IRC_SPECRED_OBSPARAM.AOT EQ '02B' then !IRC_SPECRED_SOURCEDETECTPARAM.sigma=20. $
  else                                       !IRC_SPECRED_SOURCEDETECTPARAM.sigma=5.

  case chip of
     0: begin
        !IRC_SPECRED_SOURCEDETECTPARAM.fwhm_for_find=2.7 ; 5.5
        if !IRC_SPECRED_OBSPARAM.AOT EQ '02B' then begin
           !IRC_SPECRED_SOURCEDETECTPARAM.min_noise_for_find=20.
        endif else begin
           !IRC_SPECRED_SOURCEDETECTPARAM.min_noise_for_find=10.
        endelse
        
        if NG() then !IRC_SPECRED_SOURCEDETECTPARAM.min_noise_for_find=50.
     end
     1: begin
        !IRC_SPECRED_SOURCEDETECTPARAM.fwhm_for_find=2.3 ; 3.
        !IRC_SPECRED_SOURCEDETECTPARAM.min_noise_for_find=10.
     end
     2: begin
        !IRC_SPECRED_SOURCEDETECTPARAM.fwhm_for_find=2.4 ; 4.
        !IRC_SPECRED_SOURCEDETECTPARAM.min_noise_for_find=30. ; was 15.
     end
  endcase
  
; spec detection params
  case chip of
     0: begin
        !IRC_SPECRED_SPECDETECTPARAM.flux_thresh=500
        !IRC_SPECRED_SPECDETECTPARAM.max_fwhm=7.
        !IRC_SPECRED_SPECDETECTPARAM.min_fwhm=2.
        !IRC_SPECRED_SPECDETECTPARAM.flux_thresh_for_distortion_measure=100
     end
     1: begin
        case grism of
           0: !IRC_SPECRED_SPECDETECTPARAM.flux_thresh=1000
           1: !IRC_SPECRED_SPECDETECTPARAM.flux_thresh=2000
        endcase
        !IRC_SPECRED_SPECDETECTPARAM.max_fwhm=7.
        !IRC_SPECRED_SPECDETECTPARAM.min_fwhm=1.
        !IRC_SPECRED_SPECDETECTPARAM.flux_thresh_for_distortion_measure=40; was 20
     end
     2: begin
        !IRC_SPECRED_SPECDETECTPARAM.flux_thresh=2000
        !IRC_SPECRED_SPECDETECTPARAM.max_fwhm=4.
        !IRC_SPECRED_SPECDETECTPARAM.min_fwhm=2.
        !IRC_SPECRED_SPECDETECTPARAM.flux_thresh_for_distortion_measure=10.
     end
  endcase
  
end
